define(function(require) {
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var allData = require("./js/loadData");
	require("cordova!com.justep.cordova.plugin.weixin.v3");
	require("cordova!com.justep.cordova.plugin.alipay");
	
	var Model = function() {
		this.callParent();
		this.isBack;	
	};
	
	//返回上一页
	Model.prototype.backBtnClick = function(event){
		justep.Shell.closePage();
		setTimeout(function(){
			justep.Shell.fireEvent("onRestoreContent", {});
		},500);
	};
	
	//图片路径转换
	Model.prototype.getImageUrl = function(url){
		return require.toUrl(url);
	};

	Model.prototype.shopDataCustomRefresh = function(event){
		/*
		1、加载店铺数据
		 */
		var url = require.toUrl("./cart/json/shopData.json");
		allData.loadDataFromFile(url,event.source,true);
	};
	
	//全选
	Model.prototype.allChooseChange = function(event){
		/*
		1、全选多选框绑定变化事件onChange()
		2、点击全选多选框按钮，获取其值
		3、修改商品表中的fChoose字段为全选多选框按钮的值
		*/
		var baasData1 = this.comp("baasData1");
		var choose=this.comp("allChoose").val();
		
		baasData1.each(function(obj){
			if(choose){				
				baasData1.setValue("fChoose","1",obj.row);   
			} else {
				baasData1.setValue("fChoose","",obj.row);
			}	
		});

	};
	

	
	//删除
	Model.prototype.delBtnClick = function(event){
		/*
		1、删除按钮点击事件
		2、删除选中商品
		3、如果商店里已经没有商品，则删除商店
		*/
		var baasData1 = this.comp("baasData1");
		var goodsRows = baasData1.find(["fChoose"],["1"]);
		baasData1.deleteData(goodsRows);
        baasData1.saveData();

};
	
	Model.prototype.showBackBtn = function(isBack){
		/*
		1、根据参数修改calculateData
		 */		
		this.isBack = isBack;
		var v = isBack ? 1 : 0;
		this.comp("calculateData").setValue("isBack",v);		
	};
	
	//结算事件
	Model.prototype.settlementClick = function(event){
		/*
		1、结算按钮点击事件
		2、打开订单确认页面
		3、点击确认按钮，选择支付方式
		4、进入支付成功页面
		*/	
		
		if(justep.Shell.userName.get()){
		  var baasData1 = this.comp("baasData1");
	      baasData1.saveData();
	      this.comp("popMenu1").show();  
  	  	  //justep.Shell.showPage("order",{
	  	  // isBack : this.isBack
	      //    });
	      }else{
	       justep.Util.hint("请您先登陆帐户！");
           setTimeout(function() {
		   justep.Shell.showPage("login");
			}, 1500);
	      }

	      
	};

	Model.prototype.listClick = function(event){
		/*
		 1、获取当前商品ID
		 2、传入弹出窗口，弹出窗口中显示商品详细信息
		 3、在弹出窗口的接收事件中，从服务端过滤数据
		*/
		var data=this.comp("baasDat1");
		justep.Shell.showPage("detail", {
			goodsID : data.getValue("id"),
			shopID : data.getValue("fShopID")
		});
	};

	Model.prototype.modelParamsReceive = function(event){
     		//接收参数
     	var data = this.comp('baasData1');	
        	
     	if(justep.Shell.userName.get()){
		   var p1 = justep.Shell.userName.get();
           data.setFilter('filter1',"userid="+p1); 
        }else{
           data.setFilter('filter1',"userid is null");  

        }  
        this.comp("baasData1").refreshData();   
	};


	Model.prototype.wx = function(orderID){
    	// 开始支付
    	var self = this; 	
	 	var tradeNo = orderID;   //通常是交易流水号
	 	var notifyUrl = location.origin + "/baas/weixin/weixin/notify";//支付成功通知地址
 
	 	var successCallback = function(message) {  //成功回调
	 	    //alert(JSON.stringify(message));
	 	    if (JSON.stringify(message)==0)
	 	    {
	 	    self.zfcg(orderID);
	 	    //alert("支付成功");
	 	    }else 
	 	    {
	 	    alert("支付失败");
	 	    }
	    
 		};
	
	 	var failCallback = function(message) { //失败回调
      	   alert(JSON.stringify(message));
	    };
	
 		var cancelCallback = function(message) { //用户取消支付回调
	 	    alert(JSON.stringify(message));
	    };
        var jsum = (this.calculateData.val('allSum')-this.data1.val("allSum"))*100;
        
 		var weixin = navigator.weixin;
 		weixin.generatePrepayId({ // 生成预支付id
	 		"body" : "RO纯水服务",
	 		"notifyUrl" : notifyUrl,
	 		"totalFee" : jsum,
	 		"tradeNo" : tradeNo
 		}, function(prepayId) {
 		weixin.sendPayReq(prepayId, function(message) { // 支付
	 	successCallback(message);
	 	}, function(message) {
	 	cancelCallback(message);
	 	});
	 	}, function(message) {
	 	failCallback(message);
	 	});


	};
	
    Model.prototype.zfb =  function(orderID){
        if (!navigator.alipay) {
            alert("没有安装com.justep.cordova.plugin.alipay插件，请从RO纯水官网重新下载APP！");
            return;
        }
        var self = this; 	
        var notifyUrl = location.origin;
        var tradeNo = orderID;
        var jsum = (this.calculateData.val('allSum')-this.data1.val("allSum"));
        var alipay = navigator.alipay;
        alipay.pay({
            "seller" : "1070821@qq.com",    // 卖家支付宝账号或对应的支付宝唯一用户号
            "subject" : "RO纯水服务",                           // 商品名称
            "body" : "RO纯水服务",                              // 商品详情
            "price" : jsum,                                  // 金额，单位为RMB
            "tradeNo" : tradeNo,                        // 唯一订单号
            "timeout" : "30m",                            // 超时设置
            "notifyUrl" : notifyUrl                      // 服务器通知路径
        },
        function(message) {
        var responseCode = parseInt(message);
        if (responseCode === 9000) {
            self.zfcg(orderID);
            //alert("支付成功");
            //var baasData1 = this.comp("baasData1");
            
        } else {
            alert("支付失败");
        }
        }, function(msg) {
        alert("支付失败");
    });
    
	};
	
	 Model.prototype.zfcg =  function(orderID){
	  
     var baasData1 = this.comp("baasData1");
     baasData1.each(function(obj){
     baasData1.setValue("size",1, obj.row);
     baasData1.setValue("fkuuid",orderID, obj.row);
     baasData1.saveData();
     });
     var params = {
	    UUIDS: orderID
		}
     justep.Shell.showPage("order",params);
	 };
	 
	Model.prototype.sendLiClick = function(event){
		/*
		1、支付列表点击事件
		2、选中支付方式，关闭配送列表
		*/	
		this.comp("popMenu1").hide();
	};
	
	Model.prototype.button1Click = function(event){
    //微信支付选项
	var orderID = justep.UUID.createUUID();  
    if (this.comp("calculateData").val("allSum")>0)
     {     
        var baasData2 = this.comp("baasData2");
        baasData2.each(function(obj){
            baasData2.setValue("valid",1, obj.row);
            baasData2.saveData();
        });
        this.wx(orderID);
      }
     else
     {
     alert("请先勾选您要支付的项目！");
     }
   
	};
	
	Model.prototype.button2Click = function(event){
    //支付宝支付选项
    var orderID = justep.UUID.createUUID();  
    if (this.comp("calculateData").val("allSum")>"0")
        {
         var baasData2 = this.comp("baasData2");
         baasData2.each(function(obj){
             baasData2.setValue("valid",1, obj.row);
             baasData2.saveData();
         });
         this.zfb(orderID);
        }
     else
     {
     alert("请先勾选您要支付的项目！");
     }
    
	};
	

	

	
	Model.prototype.baasData2RefreshCreateParam = function(event){
	
    event.param.variables = {"fPhoneNumber" : justep.Shell.userName.get(),
                             "fid" : 1, };

	};
	

	

	
	return Model;

});