define(function(require) {
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");	
	var allData = require("./js/loadData");	
	//require("cordova!cordova-plugin-device");
	require("cordova!com.justep.cordova.plugin.weixin.v3");


	var Model = function() {
		this.callParent();
		this.goodsID="";
		this.shopID="";
	};
	
	
	//返回上一页
	Model.prototype.backBtnClick = function(event){
		justep.Shell.closePage();
	};
	
	//接收
	Model.prototype.modelParamsReceive = function(event){
		/*
		1、参数接收事件
		2、根据参数从服务端过滤数据
		*/
		//if (this.params && this.params.shopID) {
		//	shopID = this.params.shopID;
		//	goodsID = this.params.goodsID;
		//}
		
		//接收参数
		var p1 = this.params.goodsID;
        var data = this.comp('baasData1');
        data.setFilter('filter1',"id="+p1);   
        this.comp("baasData1").refreshData();    
        
        var data3 = this.comp('baasData3');
        data3.setFilter('filter1',"id="+p1);   
        this.comp("baasData3").refreshData();
        
        


        var carousel=this.comp("carousel1");        
        data3.each(function(obj){    
                        var fImgUrl=obj.row.val("fImg");                                                   
                        if( obj.index==0){
                                $(carousel.domNode).find("img").eq(0).attr({"src":fImgUrl});
                        } else {
                                carousel.add('<img src="'+fImgUrl+'" class="image-wall tb-img"/>');
                        }
                        
                });

                
	};	
	

	

	
	//获取店铺信息
	Model.prototype.shopDataCustomRefresh = function(event){
		/*
		1、加载店铺数据
		2、根据shopID过滤数据
		 */
        var url = require.toUrl("./detail/json/shopData.json");
        allData.loadDataFromFile(url,event.source,true);       
	};
	
	//获取参数信息
	Model.prototype.parameterDataCustomRefresh = function(event){
		/*
		1、加载参数数据
		2、根据goodsID过滤数据
		 */
        var url = require.toUrl("./detail/json/parameterData.json");
        allData.loadDataFromFile(url,event.source,true);       
	};
	
	//获取评论信息
	Model.prototype.commentsDataCustomRefresh = function(event){
		/*
		1、加载评论数据
		2、根据goodsID过滤数据
		 */
		var url = require.toUrl("./detail/json/commentsData.json");
        allData.loadDataFromFile(url,event.source,true);
	};
	
	//更多评论按钮
	Model.prototype.moreBtnClick = function(event){
		/*
		1、获取当前商品ID
		2、传入新窗口，打开的窗口中显示评论列表
		3、在打开的窗口中接收数据，并从服务端过滤数据		
		*/
	};
	
	//购物车按钮
	Model.prototype.shoppingCartBtnClick = function(event){
		/*
		1、切换到购物车页面
		*/
		justep.Shell.fireEvent("onShoppingContent",{});
		justep.Shell.showMainPage();
	};
	//加入购物车
	Model.prototype.joinCartBtnClick = function(event){
		/*
		1、弹出商品尺码颜色选择框
		2、点击确定后购物车中增加一条相应数据
		*/
		if(justep.Shell.userName.get()){
			this.comp("stateData").setValue("state","0");
		    this.comp("popOver").show();
		}else{
           justep.Util.hint("请您先登陆帐户！");
           setTimeout(function() {
				justep.Shell.showPage("login");
			}, 3000);
		}

	};
	
	//购买按钮
	Model.prototype.buyBtnClick = function(event){
		/*
		1、获取当前商品ID
		2、传入新窗口，打开的窗口中显示购买确认页面
		3、在打开的窗口中接收数据，并从服务端过滤数据
		*/
		if(justep.Shell.userName.get()){
			this.comp("stateData").setValue("state","0");
		    this.comp("popOver").show();
		}else{
           justep.Util.hint("请您先登陆帐户！");
           setTimeout(function() {
				justep.Shell.showPage("login");
			}, 1500);
		}

	};
	
	//查看宝贝分类按钮
	Model.prototype.classBtnClick = function(event){
		/*
		1、获取当前商铺ID
		2、传入新窗口，打开的窗口中显示商铺分类
		3、在打开的窗口中接收数据，并从服务端过滤数据
		*/
	};
	
	//进店逛逛按钮
	Model.prototype.storeBtnClick = function(event){
		/*
		1、获取当前商铺ID
		2、传入新窗口，打开的窗口中显示店铺主页面
		3、在打开的窗口中接收数据，并从服务端过滤数据
		*/
	};
	
	//全部宝贝按钮
	Model.prototype.goodsBtnClick = function(event){
		/*
		1、获取当前店铺ID
		2、传入新窗口，打开的窗口中显示商品列表
		3、在打开的窗口中接收数据，并从服务端过滤数据
		*/
	};
	
	//分享按钮

	
	//颜色选择弹出窗显示
	Model.prototype.popOverClick = function(event){		
		this.comp("stateData").setValue("state", 1);
		this.comp("popOver").show();

	};
	
	//颜色状态修改
	Model.prototype.colorLiClick = function(event){
		/*
		1、颜色选择点击事件
		2、修改当前颜色状态
		*/

		var colorData=this.comp("baasData4");
		var row=colorData.getCurrentRow();		
		colorData.setValue("fsum", "0", colorData.find(["fsum"],["1"],true,true,true)[0]);
		colorData.setValue("fsum", "1",row);

	};	


	Model.prototype.button2Click = function(event){
	   // 生成订单数据
	  
	    var baasData2=this.comp("baasData2");
	    var colorData = this.comp("baasData4");
	    var baasData1=this.comp("baasData1");
	    var p1 = this.params.goodsID;
	    if ($.trim(colorData.val("fsum")) == 1)
	       { 
		    var orderRows = baasData2.newData({
			defaultValues : [ {
				"id" : p1,
				"Service" : colorData.val("Service"),
				"price" : colorData.val("price"),
				"userid": justep.Shell.userName.get(),
				"fTitle": baasData1.val("fTitle"), 
				"fImg": baasData1.val("fImg"),
				"fOldPrice": baasData1.val("fOldPrice")
			} ]
		    });	
	    	baasData2.saveData();

		    var userID=justep.Shell.userName.get();
		    justep.Shell.showPage("cart",userID)
          }
         else
          {
           justep.Util.hint('请选取类型');
          }
	};	








	Model.prototype.button5Click = function(event){

	};	








	Model.prototype.shareBtnClick = function(event){
		/*
		1、获取商品ID 
		2、打开分享页面
        3、参数说明 
            thumb：缩略图，可以显示商品图片，注意不能大于32kb，链接从http开始
			webpageUrl: 分享链接，使用location.href显示当前页面，链接从http开始
			scene:分享到微信朋友圈、微信朋友、微信群 
				weixin.Scene.TIMELINE 是分享到微信朋友圈
		 		weixin.Scene.SESSION 是分享给微信朋友、微信群
		*/
		if (!navigator.weixin) {
			return;
		}
		var weixin = navigator.weixin;
		var Utils = require("$UI/system/components/justep/common/utils");		
		weixin.share({
			message : {
				title :  "RO净水",
				description : "注册RO净水会员,RO净水器免费装免费用",
				mediaTagName : "Media Tag Name(optional)",
				thumb : "http://nwzimg.wezhan.cn/contents/sitefiles2012/10061395/images/1023613.jpg",
				media : {
					type : weixin.Type.WEBPAGE,
					webpageUrl : Utils.getShareUrl()
				}
			},
			scene : weixin.Scene.TIMELINE
		}, function() {
			// alert("Success");
		}, function(reason) {
			// alert("Failed: " + reason);
		});
	};	








	Model.prototype.modelLoad = function(event){

           
	};	





	Model.prototype.button1Click = function(event){
		
      justep.Util.hint('您的QQ版本过低，无法打开您的QQ！');   
	};	





	Model.prototype.button3Click = function(event){
      justep.Util.hint('您收藏了该产品！');
	};	





	Model.prototype.baasData4RefreshCreateParam = function(event){
       event.param.variables = {"id" : this.params.goodsID};
	};	





	Model.prototype.baasData5RefreshCreateParam = function(event){
     event.param.variables = {"gid" : this.params.goodsID};
	};	





	return Model;
});