define(function(require){
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var ShellImpl = require('$UI/system/lib/portal/shellImpl');
	
	var Model = function(){
		this.callParent();		
		var shellImpl = new ShellImpl(this, {
			"contentsXid" : "pages",
			"pageMappings" : {
				"main":{
					url : require.toUrl('./main.w')
				},
				"list":{
					url : require.toUrl('./list.w')
				},
				"class":{
					url : require.toUrl('./class.w')
				},
				"detail":{
					url : require.toUrl('./detail.w')
				},
				"search":{
					url : require.toUrl('./search.w')
				},
				"cart":{
					url : require.toUrl('./cart.w')
				},
				"order":{
					url : require.toUrl('./order.w')
				},
				"registemobile":{
					url : require.toUrl('./registemobile.w')
				},
				"login":{
					url : require.toUrl('./login.w')
				},
				"registeMobile":{
					url : require.toUrl('./registeMobile.w')
				},
				"personal":{
					url : require.toUrl('./personal.w')
				},
				"aboutUS":{
					url : require.toUrl('./aboutUS.w')
				},
				"store":{
					url : require.toUrl('./store.w')
				},
				"success":{
					url : require.toUrl('./success.w')
				}
			}
		});
		
	};


	Model.prototype.modelLoad = function(event){
		justep.Shell.userType = justep.Bind.observable();
		justep.Shell.userName = justep.Bind.observable();
		var userLocal = (localStorage.getItem("userUUID") && JSON.parse(localStorage.getItem("userUUID"))) || null;
		if (userLocal) {
			justep.Shell.userName.set(userLocal.name || "UNKNOWN");
			justep.Shell.userType.set(userLocal.accountType || "UNKNOWN");
		} else {
		}
	};


	return Model;
});